package org.somda.protosdc.discovery.consumer

import org.somda.protosdc.proto.model.discovery.Endpoint

/**
 * Indication of discovery events.
 */
public sealed class DiscoveryEvent {
    /**
     * An endpoint entered the network by sending a hello.
     *
     * @param endpoint the entered endpoint.
     * @param secure signifies if the event was delivered over a secured or unsecured channel.
     */
    public data class EndpointEntered(val endpoint: Endpoint, val secure: Boolean) : DiscoveryEvent()

    /**
     * An endpoint left the network by sending a bye.
     *
     * @param endpoint the left endpoint.
     * @param secure signifies if the event was delivered over a secured or unsecured channel.
     */
    public data class EndpointLeft(val endpoint: Endpoint, val secure: Boolean) : DiscoveryEvent()

    /**
     * An endpoint search timed out - generated by the consumer application.
     *
     * @param foundEndpointsCount number of endpoints found until search timed out.
     * @param discoveryId identifier of the search request.
     */
    public data class EndpointSearchTimeout(val foundEndpointsCount: Int, val discoveryId: String) : DiscoveryEvent()

    /**
     * A searched endpoint was found.
     *
     * @param endpoints found endpoints.
     * @param secure signifies if the event was delivered over a secured or unsecured channel.
     * @param discoveryId identifier of the search request.
     */
    public data class SearchedEndpointFound(
        val endpoints: Collection<Endpoint>,
        val secure: Boolean,
        val discoveryId: String
    ) : DiscoveryEvent()
}
